# Gravitational-Wave Event Generator and Follow-Up

This module is intended to hold all the ingredients to do an astrophysically realistic simulation of the GW bright universe of compact binaries and facilitate their follow up with electromagnetic instruments.

## Prerequisites

Most, if not all, of these can be installed via your favored package manager or pip.

  * numpy/scipy/matplotlib
  * h5py (a python interface to the HDF5 libraries)
  * lalsuite (https://wiki.ligo.org/DASWG/LALSuiteInstall) --- a set of packages to simulate GW sources and carry out GW searches. All that is really necessary is lal, lalsimulation, and lalinference (for BAYESTAR GW localization)
  * astropy: for cosmology related functions

## Running an Example Analysis

### Step 1: Generate a GW Event Population

To generate a population of 100 NSBH with isotropic spin direction uniform spin magnitudes, distributed uniformly in comoving distance, with otherwise uniformly distributed parameters (e.g. uniform inclinations and the like).

```bash
generate_events --generate-nsbh -N 100 --verbose --write-output test.h5
```

Note that the default is to apply "detectability" criteria for the fully advanced design sensitivity "2018-era" Hanford-Livingston-Virgo network. That criteria, specifically, is to have a signal-to-noise SNR of 5.5 in the second loudest instrument. This can be turned off by `--snr-threshold 0.0` and include a modified network with `--network H1, L1, V1, K1` (for example). All available instruments can be obtained with

```bash
generate_events --list-instruments
```

This will generate a HDF5 file with the result of the MC simulation. You can check this with `h5ls` (Note you may need to install the HDF5 utilities to obtain this command).

```
h5ls -ra test.h5
/                        Group
/events                  Group
/events/chi_eff          Dataset {100}
/events/chi_p            Dataset {100}
/events/coa_phase        Dataset {100}
/events/declination      Dataset {100}
/events/distance         Dataset {100}
/events/eccentricity     Dataset {100}
/events/eta              Dataset {100}
/events/event_time       Dataset {100}
/events/inclination      Dataset {100}
/events/mass1            Dataset {100}
/events/mass2            Dataset {100}
/events/mchirp           Dataset {100}
/events/polarization     Dataset {100}
/events/right_ascension  Dataset {100}
/events/spin1x           Dataset {100}
/events/spin1y           Dataset {100}
/events/spin1z           Dataset {100}
/events/spin2x           Dataset {100}
/events/spin2y           Dataset {100}
/events/spin2z           Dataset {100}
/events/z                Dataset {100}
```

### Perform GW Event Localization

Example:

```bash
./localize_events test.h5 --write-output test_localize/test_loc
```

This is just a thin wrapper over a loop which does a BAYESTAR localization for each event. Different networks can be used to examine the localization with various instrument configurations. One can then use `bayestar_plot_volume` to visualize the resulting FITS files. GW localizations can be turned off with the `-B` option.

### Generate Event Light Curves

The `localize_events` executable will generate light curves for each event unless asked explicitly not to. These light curves are saved to the file stem given on the `localize_events` command line with an `.h5` extension. Example:

```bash
h5ls -ra test_localize/test_loc.0.h5
/                        Group
/light_curves            Group
/light_curves/b_light_curve Dataset {100}
/light_curves/flux       Dataset {100, 10000}
/light_curves/freq       Dataset {10000}
/light_curves/g_light_curve Dataset {100}
/light_curves/i_light_curve Dataset {100}
/light_curves/r_light_curve Dataset {100}
/light_curves/times      Dataset {100}
/light_curves/u_light_curve Dataset {100}
/light_curves/y_light_curve Dataset {100}
/light_curves/z_light_curve Dataset {100}
```

As can be seen, the "flux" (at frequencies denoted by `freq`) from the source is saved (really the luminosity in the kN case), as well as the bandlimited flux in magnitudes realized at the Earth (the light curves in different bands). The `times` column corresponds to the sampled times from the source simulation. Each dataset has attributes describing units and other useful information.

#### Kilonovae

The kN light curves are generated by a toy model derived from the Kilonova Hanbook (Metzger, 2016). It is parameterized by the total ejecta mass and distance to the source. The model itself is implemented in the `kilonovae` python library code. Two "versions" are available: the short-lived "Lanthanide-free" blue kilonovae and the long-lived "Lanthanide-rich" red kilonovae. The reader interested in the details of these models is referred to the Handbook for more.

#### GRB

Coming soon.

### Examine LSST Followup

#### Survey Mode

The `check_coincidence` code will do a follow up on an input population of events. It calculates the probability of an event being observed by LSST in its normal survey cadence and also the probability of N events being observed in coincidence between the two observatories.

```bash
./check_coincidence test.h5
```

The `generate_obs` code will generate observations for a given strategy (current default and only implemented is brute force) from scanning over a GW sky map. This annotates a light curve with the times it would be observed. These can then be plotted by `plot_all_light_curves`.

```bash
./generate_obs test_localize/test_loc.*.h5 --event-database test.h5
```


### Compiling and Plotting Localization Statistics
The `localization_statistics.py` and `plot_loc_stats.py` codes can be used in tandem to compile sky area values from fits files and plot these sky areas in a series of histograms and scatterplots. First, `localization_statistics.py` searches a collection of `.fits` files and outputs a `.txt` file where each line gives an event number followed by 50% and 90% confidence regions on sky area. This can be run as follows:

```
python localization_statistics.py -i "nsbh_full_100_snr/*.fits" -o "nsbh_full_100_snr/areas_nsbh_full_snr.txt"
```

The outputted `areas_nsbh_full_snr.txt` is then fed into `plot_loc_stats.py` as follows:

```
python plot_loc_stats.py -i nsbh_full_100_snr/areas_nsbh_full_snr.txt -o nsbh_full_100_snr/nsbh_full_100_snr
```

This will create multiple figures with names beginning with the stem provided with the `-o` flag. To create a scatterplot with SNR information, a `.txt` file containing SNR information of a specific format must be provided. `plot_loc_stats.py` assumes a file called `event_snr.txt` exists, with each line recording an event number, network SNR, and SNRs for each interferometer used in event generation. A short example is provided below:

```
0, 10.84, 3.45, 7.74, 6.76
1, 9.04, 3.34, 6.02, 5.85
2, 10.90, 3.12, 6.94, 7.80
```

